//
//  BCJavascriptInterface.m
//  BarCampSkeleton
//
//  Author: George Brocklehurst, http://georgebrock.com
//  Released under Creative Commons BY 2.0
//  http://creativecommons.org/licenses/by/2.0/uk/
//

#import "BCJavascriptInterface.h"
#import "BCAppDelegate.h"


@implementation BCJavascriptInterface

// Standard method, part of the WebScripting informal protocol
// Called to transform Obj-C method names to JS function names
// Default transformation is to replace 
//   : with _
//   _ with $_
//   $ with $$
// Better to define your own!
+ (NSString*)webScriptNameForSelector:(SEL)sel
{
	if(sel == @selector(exampleMethod))
		return @"exampleMethod";
		
	return nil;
}

// Standard method, part of the WebScripting informal protocol
// Allows methods on this object to be hidden from Javascript
+ (BOOL)isSelectorExcludedFromWebScript:(SEL)sel
{
	// To exclude a method use:
	//if(sel == @selector(methodToExclude:))
	//	return TRUE;
		
	// By default, show all methods to JS
	return FALSE;
}

// An example method that can be called by the Javascript
- (NSString*)exampleMethod
{
	// Call the exampleCallback() Javascript function
	[[NSApp delegate] 
		callJavascriptFunction:@"exampleCallback" 
		withArguments:[NSArray arrayWithObject:@"This value was set by calling a JS function from Cocoa"]];
		
	// Return a nice method
	return @"Hello world! (This message returned by a Cocoa method)";
}


@end
